/**************/
/* testdll.c  */
/****************************************************************************
    PROGRAM: TESTDLL.C
    PURPOSE: Ohjelma STRLIB-kirjaston testaamiseksi.
    Editor:  Vesa Lappalainen  9.11.1992
    PROJECT: Ohjelma voidaan knt kyttmn joko .DLL-kirjastoa
             tai tavallista kirjastoa.

          STRDLL-kirjasto:
             1) Knn STRDLL.C siell olevien ohjeiden mukaan STRDLL.DLL:ksi
             2) Tee tlle pohjelmalle projekti:
                  TESTDLL.C
                  TESTDLL.DEF   (jossa on rivi: IMPORTS STRDLL.KysyJono)
                                (tai laita viel projektiin STRDLL.LIB )
          Tavallinen kirjasto:
             1) Tee projekti:
                  TESTDLL.C
                  KYSYJONO.DEF
                  STRLIB.C
                  STRLIB.RC

****************************************************************************/
#include <windows.h>            /* Tarvitaan kaikissa Windows C-ohjelmissa */
#include <string.h>
#include "strlib.h"

#define WCLASSNAME "WKysyjonoWClass"

/***************************************************************************/
LONG CALLBACK_E MainWndProc(HWND hWnd, unsigned message,
                                  WPARAM wParam, LPARAM lParam)
{
    PAINTSTRUCT ps;
    static char jono[8]="Vesa";

    switch (message)
    {
        case WM_PAINT:            /* Viesti: Piirr ikkuna uudelleen       */

            if ( BeginPaint(hWnd,&ps) )
              TextOut(ps.hdc, 10, 10, jono,strlen(jono));
            EndPaint(hWnd,&ps);
            return (NULL);

        case WM_LBUTTONDOWN:
        case WM_CHAR:
            KysyJono("Mik on nimesi?",jono,jono,sizeof(jono));
            InvalidateRect(hWnd,NULL,TRUE);
            break;

        case WM_DESTROY:          /* Viesti: ikkuna hvitetn             */
            PostQuitMessage(0);
            return (NULL);

        default:                  /* Antaa Windowsin ksitell muut        */
            break;
    }
    return (DefWindowProc(hWnd, message, wParam, lParam));
}

/***************************************************************************/
int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
                   LPSTR lpCmdLine, int nCmdShow)
{
#pragma argsused
    WNDCLASS  wc;   /* Ikkunaluokka                                        */
    HWND    hWnd;   /* Pikkunan kahva                                    */
    MSG msg;        /* Viesti                                              */

    if (!hPrevInstance) {       /* Onko muita esiintymi kynnisss?       */
      wc.style         = NULL;           wc.lpfnWndProc    = MainWndProc;   
      wc.cbClsExtra    = 0;              wc.cbWndExtra     = 0;              
      wc.hInstance     = hInstance;       
      wc.hIcon         = LoadIcon(NULL, IDI_APPLICATION); 
      wc.hCursor       = LoadCursor(NULL, IDC_ARROW);   
      wc.hbrBackground = GetStockObject(GRAY_BRUSH); 
      wc.lpszMenuName  = NULL;           wc.lpszClassName  = WCLASSNAME;
      if (!RegisterClass(&wc)) return (FALSE);  
    }

    hWnd = CreateWindow(WCLASSNAME,"Kysy jono -testi",WS_OVERLAPPEDWINDOW,
                        CW_USEDEFAULT,CW_USEDEFAULT,300,150,
                        NULL,NULL,hInstance,NULL);
    if (!hWnd) return (FALSE);
    ShowWindow(hWnd, nCmdShow);     /* Nytetn ikkuna                    */
    UpdateWindow(hWnd);             /* Lhetetn WM_PAINT viesti          */

    while (GetMessage(&msg,NULL,NULL,NULL)) {
        TranslateMessage(&msg);     /* Tulkitaan virtuaaliset np. koodit  */
        DispatchMessage(&msg);      /* Lhetetn viesti ikkunalle         */
    }
    return (msg.wParam);      /* Palautetaan PostQuitMessage-funktion arvo */
}