/**************/
/* vaihtaj2.c */
/****************************************************************************
    PROGRAM: vaihtaj2.c
    PURPOSE: Vaihtaa rahaa ja matkoja
             Ohjelmalla esitelln omatekoisten dialog boxien kytt.
             Pikkuna tekee vain menun, jolla voidaan valita mik
             dialog box tulee aktiiviseksi

             Skaalausvaihtajan oletusikkunana on luonnosta mitattu
             matka.  Painamalla ENTER (IDOK) pstn aina thn ikkunaan.
             Kun ikkunaan tullaan, valitaan koko ikkunassa oleva teksti, jotta
             uuden syttminen olisi helpompaa.

             Ikkunoiden toimintajrjestys on valittu Resource Workshopissa
             toiminnolla Options - Set order.

             Ikkunat ovat kytettviss yhtaikaa jos ne on luotu Modeless.
             Modeless-dialogien on kyttn omat aliohjelmat,
             jotka tallettavat kaikki kyttn otetut modeless dialogit.
             Modeless tai Modal dialogi valitaan kutsun perusteella
               DoModelessDialog tai
               DoModalDialog.
             Itse dialogit voivat olla samoja, mikli ne lopetetaan
             kutsuun DestroyDialog.

    PROJECT:
      vaihtaj2.c
      vaihtaja.rc
      vaihtaja.def
      mdialog.c

    TEHTVI:
             1)  Tydenn rahanvaihto-toiminto valmiiksi.

             2)  Kokeile muuttaa dialogin oletusjrjetyst (RWSHOP!)
             
             3)  Vain yksi modeless esiintym kustakin dialogista voi olla kerrallaan
                 kynniss!  Miksi?

             4)  Miten voisit korjata ongelman?
             
    Editor:  Vesa Lappalainen 26.10.1992 
****************************************************************************/
#include <windows.h>            /* Tarvitaan kaikissa Windows C-ohjelmissa */
#include <stdio.h>     
#include <string.h>
#include <math.h>
#include "mdialog.h"
#include "tabhand.h"
#include "vaihtaja.h"

#define WCLASSNAME "WMultiWClass"
TDIALOGPROC(ScalingMsgTbl,Scaling)


/***************************************************************************/
static EVENT WM_paint(tMSGParam *msg) /* # 1 # */
{
  static char viesti[]="Valitse menusta ohjelma!";
  return TextOut(msg->hDC, 10, 10, viesti,strlen(viesti));
}

static EVENT WM_command_IDM_FILE_EXIT(tMSGParam *msg)
{
  return SendMessage(msg->hWnd,WM_DESTROY,0,0);
}

static EVENT WM_command_IDM_APP_SCALING(tMSGParam *msg)
{
  return DoMultiModelessDialog(msg->hWnd,"SCALING",Scaling);
}

static EVENT WM_command_IDM_APP_MONEY(tMSGParam *msg)
{
  return DoMultiModelessDialog(msg->hWnd,"CHANGE",About);
}

static EVENT WM_command_IDM_HELP_ABOUT(tMSGParam *msg) /* #man# */
{
  return DoModalDialog(msg->hWnd,"About",About);
}

/****************************************************************************/
#define DoC DONT_CARE

static tMSGEntry MsgTbl[] = {
  { WM_PAINT       , DoC             , DoC, WM_paint                   , 1 },
  { WM_COMMAND     , IDM_FILE_EXIT   , DoC, WM_command_IDM_FILE_EXIT   , 0 },
  { WM_COMMAND     , IDM_APP_SCALING , DoC, WM_command_IDM_APP_SCALING , 0 },
  { WM_COMMAND     , IDM_HELP_ABOUT  , DoC, WM_command_IDM_HELP_ABOUT  , 0 },
  { WM_COMMAND     , IDM_APP_MONEY   , DoC, WM_command_IDM_APP_MONEY   , 0 },
  { 0 }
};

TWINDOWPROC(MsgTbl,MainWndProc)

/***************************************************************************/
int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
                   LPSTR lpCmdLine,  int nCmdShow)
{
#pragma argsused
    WNDCLASS  wc;   /* Ikkunaluokka                                        */
    HWND    hWnd;   /* Pikkunan kahva                                    */
    MSG msg;        /* Viesti                                              */

    if (!hPrevInstance) {       /* Onko muita esiintymi kynnisss?       */
      wc.style         = NULL;      wc.lpfnWndProc    = MainWndProc;
      wc.cbClsExtra    = 0;         wc.cbWndExtra     = 0;
      wc.hInstance     = hInstance;
      wc.hIcon         = LoadIcon(hInstance, "Ikoni");
      wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
      wc.hbrBackground = (HBRUSH)GetStockObject(GRAY_BRUSH);
      wc.lpszMenuName  = "MAINMENU";     wc.lpszClassName  = WCLASSNAME;
      if (!RegisterClass(&wc)) return (FALSE);
    }

    hWnd = CreateWindow(WCLASSNAME,"Vaihtaja",WS_OVERLAPPEDWINDOW,
                        20,20,400,400,
                        NULL,NULL,hInstance,NULL);
    if (!hWnd) return (FALSE);
    ShowWindow(hWnd, nCmdShow);     /* Nytetn ikkuna                    */
    UpdateWindow(hWnd);             /* Lhetetn WM_PAINT viesti          */

    while (GetMessage(&msg,NULL,NULL,NULL)) {
        if ( IsModelessMessage(&msg) ) continue;
        TranslateMessage(&msg);     /* Tulkitaan virtuaaliset np. koodit  */
        DispatchMessage(&msg);      /* Lhetetn viesti ikkunalle         */
    }

    FreeAllModeless();

    return (msg.wParam);      /* Palautetaan PostQuitMessage-funktion arvo */
}
