/**************/
/* vaihtaj3.c */
/*****************************************************************************
    PROGRAM: vaihtaj3.c
    PURPOSE: Vaihtaa rahaa ja matkoja
             Ohjelmalla esitelln omatekoisten dialog boxien kytt.
             Pikkuna tekee vain menun, jolla voidaan valita mik
             dialog box tulee aktiiviseksi

             Skaalausvaihtajan oletusikkunana on luonnosta mitattu
             matka.  Painamalla ENTER (IDOK) pstn aina thn ikkunaan.
             Kun ikkunaan tullaan, valitaan koko ikkunassa oleva teksti, jotta
             uuden syttminen olisi helpompaa.

             Ikkunoiden toimintajrjestys on valittu Resource Workshopissa
             toiminnolla Options - Set order.

             Ikkunat ovat kytettviss yhtaikaa jos ne on luotu Modeless.
             Modeless-dialogien on kyttn omat aliohjelmat,
             jotka tallettavat kaikki kyttn otetut modeless dialogit.
             Modeless tai Modal dialogi valitaan kutsun perusteella
               DoModelessDialog tai
               DoModalDialog.
             Itse dialogit voivat olla samoja, mikli ne lopetetaan
             kutsuun DestroyDialog.

         t   Thn malliin on listty mys esimerkki ohjelman kntmisest
             kielelt toiselle (lisykset merkitty t = translate)

        ac   Pikanppinten ksittely listty (merkitty ac = accelarator).

         h   Avustus (help).  (merkitty h = help )

       csh   Sisltriippuva avustus (merkitty csh = context sensitive help)

         v   Versio-informaatio             // ei tehty

         a   About-dialogin ksittely       // ei version hallintaa

    PROJECT:
      vaihtaj3.c
      vaihtaja.rc
      vaihtaja.def
      scalin3.c
      ALI\tabhand.c
      ALI\mdialog.c
      ALI\showdoub.c
      ALI\transdlg.c
      ALI\language.c
      ALI\mjonot.c
      ALI\help.c

    TEHTVI:
             1)  Tydenn rahanvaihto-toiminto valmiiksi.

             2)  Muuta ohjelmaa siten, ett aina kun mittakaavadialogi
                 kynnistetn, kytetn sen edelliselt kerralta
                 jneit arvoja (mittakaava, muunnos, map-matka, yksikt)

             3)  Kielen vaihtaminen ei ulotu yksikihin.  Miten
                 korjaisit asian?

             4)  Mit pit tehd, jotta englanninkielinen avustuskin toimisi?

             5)  Muuta muunnos-ohjelma yleiseksi siten, ett sit ohjataan
                 seuraavan nkisell VAIHTAJA.INI-tiedostolla.  Tiedoston
                 lukemisen jlkeen menu muuttuu sen mukaan montako [Change?]
                 sektiota saatiin luettua.

;-----------------------------------------------------------------------------
[Change0]
title   = Mittakaavamuunnos
menu    = &Scaling
help    = Muuta mittakaavaksi 1:1 jos haluat tehd yksikkmuunnoksia
from    = &Kartalla
to      = &Luonnossa
scale   = &Mittakaava
;     yksikk           kerroin    lisys
do0 = mm,                1.0     , 0
do1 = cm,               10.0     , 0
...jne..
do17= lentopinta,    30400.8     , 0
[Change1]
title   = Rahanvaihto
menu    = &Money Change
from    = &Mist
to      = M&ihin
do0 = mk,                1.0     , 0
do1 = $ ,                4.68    , 0
...jne...
[Change2]
title   = Lmptilan muunnos
menu    = &Temperature
from    = &Mist
to      = M&ihin
do0 = C ,                1.0     , 0
do1 = K ,                1.0     , -273.1
...jne...
;-----------------------------------------------------------------------------

    Editor:  Vesa Lappalainen 13.7.1993
*****************************************************************************/
#define VERSION "0.5 20.8.1995"

#include <windows.h>            /* Tarvitaan kaikissa Windows C-ohjelmissa  */
#include <stdio.h>
#include <string.h>
#include "portable.h"
#include "tmdialog.h"                                                /* avt */
//#include "tabhand.h"
//#include "transdlg.h"                                                /* t */
#include "help.h"                                                    /* csh */
#include "vaihtaja.h"

static tVersionInfo Version = {IDC_VERSION,"Version "mPLATFORM": "VERSION};
                                                                       /* v */

/****************************************************************************/
TDIALOGPROC(ScalingMsgTbl,Scaling);
TrINITPROC(Scaling,IScaling,BOOL);                                     /* t */
TrINITPROC(MDialogAbout,TMDialogAbout,BOOL);                           /* t */
TblClassWindowMAIN("VaihtajaClass","Ikoni","Vaihtaja",MsgTbl,0);

#define HELPTABLE 0
#if HELPTABLE
/****************************************************************************/
tHelpTable HelpTable[] = {                                           /* csh */
  { IDR_OTHER,	    "naapuri"    },
  { IDR_THIS,	    "oma"        },
  { ID_MAP_DIST,    "menu_file"  },
  { ID_MAP_UNIT,    "lopeta"	 },
  { ID_OUT_DIST,    "combobox"   },
  { ID_OUT_UNIT,    "combobox"   },
  { ID_SCALE,       "mittakaava" },
  { 0 }
};
#endif

/****************************************************************************/
static EVENT WM_paint(tMSGParam *msg) /* # MAKE_DC # */
{
  const char *viesti = T("Valitse menusta ohjelma!"); /* HUOM! EI static! t */
  return TextOut(msg->hDC, 10, 10, viesti,strlen(viesti));
}

static EVENT WM_create(tMSGParam *msg)
{
  mAddAccelerator(msg->hWnd,"Pika");                                  /* ac */
  MoveWindow(msg->hWnd,20,20,400,400,FALSE);
  SetClassBackround(msg->hWnd,GetStockObject(GRAY_BRUSH));
  return 0;
}

static EVENT WM_destroy(tMSGParam *msg)                                /* t */
{
  free_translate();                                                    /* t */
  WinHelp(msg->hWnd,T("VAIHTAJA.HLP"),HELP_QUIT,0);                    /* h */
  PostQuitMessage(0);
  return 0;
}

static EVENT WM_command_IDM_FILE_EXIT(tMSGParam *msg)
{
  return SendMessage(msg->hWnd,WM_DESTROY,0,0);
}

static EVENT WM_command_IDM_ENGLISH(tMSGParam *msg)                    /* t */
{
  return TranslateProgramAndRead(msg->hWnd,"vaihtaja.tra");
}

static EVENT WM_command_IDM_FINNISH(tMSGParam *msg)                    /* t */
{
  return TranslateProgram(msg->hWnd,1);
}

static EVENT WM_command_IDM_APP_SCALING(tMSGParam *msg)
{
#if 1 /* Knns joko nin: */
  DoMultiModelessDialog(msg->hWnd,"SCALING",IScaling); return 0;       /* t */
#else /* Tai nin: (toimii vain modeless-dialogit!  Miksi?) */
  HWND hDlg = DoMultiModelessDialog(msg->hWnd,"SCALING",Scaling);      /* t */
  TranslateDialog(hDlg); return 0;
#endif
//  DoModelessDialog(msg->hWnd,"SCALING",Scaling); return 0;
//  DoModalDialog(msg->hWnd,"SCALING",Scaling); return 0;
}

static EVENT WM_command_IDM_APP_MONEY(tMSGParam *msg)
{
  DoModalDialog(msg->hWnd,"CHANGE",TMDialogAbout); return 0;           /* t */
}                               /* ^^^^^^^^^^^^^ */

static EVENT WM_command_CM_HELPINDEX(tMSGParam *msg)                   /* h */
{
  return WinHelp(msg->hWnd,T("VAIHTAJA.HLP"),HELP_INDEX,0);            /* t */
}                       /* ^^              ^                             t  */

/****************************************************************************/
EVENT EVENT_handler_TAbout(tMSGParam *msg) /* #man# */
{
  return (int)DoModalDialogParam(msg->hWnd,"About",TMDialogAbout,msg->extra);
}

/****************************************************************************/
static EVENT WM_command_CM_HELPCS(tMSGParam *msg)                   /* csh */
{
#if HELPTABLE
  return DoHelpOnFocus(msg->hWnd,T("VAIHTAJA.HLP"),HelpTable);         /* t */
#else /* Yksinkertaisempi nin: */
  return DoHelpOnFocusID(msg->hWnd,T("VAIHTAJA.HLP"));                 /* t */
#endif
}

/****************************************************************************/
static tMSGEntry MsgTbl[] = {
  EV_HANDLE_TWM_COMMAND_CM_HELPABOUT(&Version)                       /* avt */
  { WM_PAINT , DoC , DoC , WM_paint,  MAKE_DC  }, /*a*/
  { WM_CREATE , DoC , DoC , WM_create }, /*a*/
  { WM_DESTROY , DoC , DoC , WM_destroy }, /*a*/
  { WM_COMMAND , IDM_FILE_EXIT , DoC , WM_command_IDM_FILE_EXIT }, /*a*/
  { WM_COMMAND , IDM_ENGLISH , DoC , WM_command_IDM_ENGLISH }, /*a*/
  { WM_COMMAND , IDM_FINNISH , DoC , WM_command_IDM_FINNISH }, /*a*/
  { WM_COMMAND , IDM_APP_SCALING , DoC , WM_command_IDM_APP_SCALING }, /*a*/
  { WM_COMMAND , IDM_APP_MONEY , DoC , WM_command_IDM_APP_MONEY }, /*a*/
  { WM_COMMAND , CM_HELPINDEX , DoC , WM_command_CM_HELPINDEX }, /*a*/
  { WM_COMMAND , CM_HELPCS , DoC , WM_command_CM_HELPCS }, /*a*/
  { 0 }
};
/***************************************************************************/
